'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _actionTypes = require('./actionTypes');

var actions = _interopRequireWildcard(_actionTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

exports.default = function (load) {
  return function (store) {
    store.dispatch({
      type: actions.STATE_LOADING_START
    });
    load().then(function (state) {
      store.dispatch({
        type: actions.STATE_LOADING_DONE,
        payload: { state: state }
      });
    }, function (error) {
      store.dispatch({
        type: actions.STATE_LOADING_FAILED,
        payload: { error: error }
      });
    });
    return function (next) {
      return function (action) {
        return next(action);
      };
    };
  };
};